if(isPackage(fairy))deactivatepackage(fairy);
package fairy 
{
   function Armor::onAdd(%t,%o)
   {
      Parent::onAdd(%t,%o);
      if(%o.getType() & $TypeMasks::PlayerObjectType && isObject(%o.client) && (%o.client.spawnFairy && $Fairy::Spawn || $Fairy::ForceSpawn))
         %o.spawnFairy();
   }
   function Armor::onTrigger(%data,%player,%slot,%io)
	{
      if(%player.getType() & $TypeMasks::PlayerObjectType && isObject(%player.client))
         %player.fairySlot[%slot] = %io;
		Parent::onTrigger(%data,%player,%slot,%io);
	}
};
activatepackage(fairy);
function servercmdUpdateSpawn(%c)
{
   if(%c.isSuperAdmin)
   {
      $Fairy::Spawn=!$Fairy::Spawn;
      messageAll('MsgAdminForce',"\c3"@%c.name@"\c0 updated Fairy Spawning to \c3"@($Fairy::Spawn?"\c2Enabled":"\c0Disabled"));
   }
}
function servercmdUpdateForcedSpawn(%c)
{
   if(%c.isSuperAdmin)
   {
      $Fairy::ForceSpawn=!$Fairy::ForceSpawn;
      messageAll('MsgAdminForce',"\c3"@%c.name@"\c0 update Forced Fairy Spawning to \c3"@($Fairy::ForceSpawn?"\c2Enabled":"\c0Disabled"));
   }
}
function servercmdToggleFairy(%c)
{
    messageClient(%c,'',"Fairy Spawning for you is \c3"@(%c.spawnFairy=!%c.spawnFairy?"\c2Enabled":"\c0Disabled"));
}
function servercmdClearFairies(%c)
{
   if(%c.isSuperAdmin)
   {
      %m=0;
      %a=ClientGroup.getCount();
      for(%i=0;%i<%a;%i++)
      {
         %t=ClientGroup.getObject(%i);
         %p=%t.player;
         if(isObject(%p.fairy))
         {
            %m++;
            %p.fairy.delete();
         }
      }
      if(%m)
         messageAll('MsgAdminForce',"\c3"@%c.name@"\c0 cleared all Fairies ("@%m@")");
   }
}
function servercmdFairyHelp(%c)
{
   messageClient(%c,'',"\c5Fairy Commands\c6:");
   messageClient(%c,'',"\c4/killFairy\c6 - Deletes a fairy");
   messageClient(%c,'',"\c4/newFairy\c6 - Creates/Changes a fairy");
   messageClient(%c,'',"\c4/toggleFairy\c6 - Toggle automatic fairy spawning");
   if(%c.isSuperAdmin)
   {
      messageClient(%c,'',"(SA)\c4/clearFairies\c6 - Removes all fairies");
      messageClient(%c,'',"(SA)\c4/updateSpawn\c6 - Toggles fairy spawning");
      messageClient(%c,'',"(SA)\c4/updateForcedSpawn\c6 - Toggles forced fairy spawning");
   }
}
function getNiceLightDatas()
{
   $lightDatas=-1;
   for(%i=0;%i<datablockGroup.getCount();%i++)
   {
      if((%d=datablockGroup.getObject(%i)).classname $= "fxLightData")
      {
         if(%d.AnimColor||%d.AnimBrightness||%d.AnimRadius||%d.AnimOffsets||%d.AnimRotation)
            continue;
         $lightData[$lightDatas++]=%d.getName();
      }
   }
}
function randomLight()
{
   if(!strLen($lightDatas))
      getNiceLightDatas();
   return $lightData[getRandom(0,$lightDatas)];
}
function Player::spawnFairy(%t)
{
   %n = new fxLight()
   {
      datablock = randomLight();
      dist=10;
      radius=getRandom()*4+2; 
      lift=getRandom()*0.2+0.1;
      vert=getRandom()*2-1; 
      freq=getRandom()*0.01+0.01*(getRandom(0,1)?1:-1); 
      height=getRandom()*2;
      speed=getRandom()/2+0.01;
      owner=%t;
      position = getRandom(-200,200) SPC getRandom(-200,200) SPC getRandom(0,200);
   };
   %t.fairy = %n;
   %n.fairyTick();
}
function fxLight::fairyTick(%t)
{
   cancel(%t.fairySched);
   if(!isObject(%t.owner))
   {
      %t.delete();
      return;
   }
   %t.moveTo(%t.getFairyPos(%t.tickCount++));
   %t.reset();
   %t.fairySched=%t.schedule(16,fairyTick);
}
function fxLight::moveTo(%t,%p)
{
   %t.setTransform(midPos(%t.getPosition(),%p,%t.speed));
}
function midPos(%a,%b,%s)
{
   %sub=vectorNormalize(vectorsub(%b,%a));
   %fraction = vectorDist(%b,%a)*%s;
   %vector=vectorScale(%sub,%fraction);
   %newpos=vectorAdd(%vector,%a);
   return %newpos;
}
function servercmdChangeFairy(%c,%d)
{
   if(isObject(%p=%c.player) && %c.lastChangeFairy + 5000 < getSimTime())
   {
      if(isObject(%f=%p.fairy) && isObject(%d))
      {
         if(%d.getClassName()!$="fxLightData")
            return;
         %f.setDatablock(%d);
         messageClient(%c,'',"\c6Fairy changed to \c4"@%d.uiname);
         %c.lastChangeFairy=getSimTime();
      }
   }
}
function servercmdkillFairy(%c)
{
   if(isObject(%p=%c.player) )
      if(isObject(%f=%p.fairy))
         %f.delete();
}
function servercmdnewFairy(%c)
{
   if(isObject(%p=%c.player) && %c.lastNewFairy + 5000 < getSimTime())
   {
      if(isObject(%f=%p.fairy))
         %f.delete();
      %p.spawnFairy();
      %c.lastNewFairy=getSimTime();
   }
}
function fxLight::getFairyPos(%t,%a)
{
   if(isObject((%p=%t.owner).light))
   {
      if(%p.fairySlot0 && %t.dist < 50)
         %t.dist+=%t.speed;
      if(%p.fairySlot4 && %t.dist > 2)
         %t.dist-=%t.speed;
      %start = %p.getEyePoint();
      %targets = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
      %vec = %p.getEyeVector();
      %end = vectorAdd(%start,vectorScale(%vec,%t.dist));
      %ray = containerRaycast(%start,%end,%targets,%p);
      %col = firstWord(%ray);
      %pos = posFromRaycast(%ray);
      if(%pos == 0)
         %pos = vectorAdd(vectorScale(%p.getEyeVector(), %t.dist),%p.getEyePoint());
      return %pos;
   }
   else
   {
      %t.dist=10;
      return %t.getHeadPos(%a);
   }
}
function fxLight::getHeadPos(%t,%a)
{
   %p=%t.owner;
   %z=%t.vert;
   %z=%t.vert;
   %b=vectorAdd(%p.getEyePoint(),"0 0 "@%z);
   %f=%t.freq;
   %r=%t.radius;
   %h=%t.height;
   %l=%t.lift;
   %n=mCos(%a*%f)*%r SPC mSin(%a*%f)*%r SPC mSin(%a*%l)*%h;
   return vectorAdd(%b,%n);
}